program DS (input,output);
uses CRT;
const
     maxn = 4;          { maximum number of alternatives }
     twomax = 16;       { two to the maxn power }
type
    BinaryType = array[1..twomax] of integer;
var
     n,size,k,i,j,Tn,x,y    : integer;
     m1, m2, m3 : array[1..twomax] of real;
     normal,mass,sum1,sum2 : real;
     A    :  array[1..maxn] of string;
     b,b1,b2,b3,b4,zero    :  BinaryType;
     error, done : boolean;
     try :char;
{********************************************************************}
{**    This procedure will convert an arbitary integer             **}
{**    into a binary vector.  The least significant bit            **}
{**    is stored at location 1.  The number of bits is             **}
{**    given by size.                                              **}
{********************************************************************}
procedure Convert_to_Binary (i:integer; var b : BinaryType; var size : integer);
var
   j : integer;
begin
     for j:=1 to twomax do
         b[j]:=0;
     j:=1;
     while i > 0 do
           begin
                if odd(i) then b[j]:=1;
                j:=j+1;
                i:= i div 2
           end;
     size:=j-1
end;

{********************************************************************}
{**      This procedure will initialize your belief system.        **}
{**      It will prompt you for the number of alternatives         **}
{**      and the mass assignment under each belief.                **}
{********************************************************************}
procedure initialize;
var
   i,x,y  :  integer;
begin
     TextBackground(Blue);
     TextColor(Yellow);
     ClrScr;
     writeln;
     writeln('               Welcome to the Dempster/Shafer Belief');
     writeln('                        Calculator System');
     writeln;
     writeln('     I will take two different belief assignments over the same set');
     writeln('     of alternatives and combine them into a single belief assignment');
     writeln;
     writeln('  First, I need some basic information from you...');
     writeln;
     write('How many alternatives are there? ');
     readln(n);
     writeln;
     writeln('Now I would like a name given to each alternative');
     writeln;
     for i := 1 to n do
         begin
              write('Enter Alternative ',i:2,'  ');
              readln(A[i]);
         end;
     writeln;
     done:=false;
     while not done do
           begin
                Tn:=1;
                for i:=1 to n do
                    Tn:=2*Tn;
                writeln('Mass assignments for belief one');
                writeln;
                for i:=1 to Tn-1 do
                    begin
                         ClrScr;
                         Convert_to_Binary(i,b,size);
                         writeln('The current set of alternatives is:');
                         for j:=1 to n do
                             if b[j]=1 then writeln(A[j]);
                         writeln;
                         write('Enter its mass assignment for belief one:  ');
                         readln(m1[i]);
                         write('Enter its mass assignment for belief two:  ');
                         readln(m2[i]);
                    end;
                sum1:=0;
                sum2:=0;
                for i:=1 to Tn-1 do
                    begin
                         sum1:=sum1+m1[i];
                         sum2:=sum2+m2[i]
                    end;
                if (sum1=1.0) and (sum2=1.0) then
                   done:=true
                else
                  begin
                       writeln;
                       writeln('YOUR MASS ASSIGNMENTS DO NOT ADD TO ONE');
                       write('Do you want to try again? (Y/N)');
                       readln(try);
                       if try='N' then done:=true
                  end;
           end;
     ClrScr;
     writeln('                 SUMMARY OF ASSIGNMENTS');
     writeln;
     writeln('Position    Alternative');
     for i:=1 to n do
         writeln('   ',i:2,'        ',A[i]);
     writeln;
     x:=WhereX;
     y:=WhereY;
     writeln('   Alternatives        Mass1      Mass2');
     for i:=1 to Tn-1 do
         begin
              Convert_to_Binary(i,b,size);
              y:=y+1;
              write('        ');
              for j:=1 to n do
                  write(b[j]:1);
              GotoXY(25,y);
              writeln(m1[i]:3:2,'       ',m2[i]:3:2)
         end;
     writeln;
     writeln('Hit Return to continue');
     readln
end;
{********************************************************************}
{**      This procedure will determine the common subset           **}
{**      of alternatives between two belief subsets                **}
{********************************************************************}
procedure common(n:integer; b1,b2 : BinaryType; var b3:BinaryType);
var i : integer;
begin
     for i:=1 to n do
         if (b1[i] = 1) and (b2[i]=1) then b3[i]:=1
         else b3[i]:=0;
end;
{********************************************************************}
{**      This function determines if two sets of alternatives      **}
{**      are equal.                                                **}
{********************************************************************}
function equal(n:integer; b1,b2:BinaryType) : Boolean;
var i: integer;
begin
     equal := true;
     for i:=1 to n do
         if b1[i] <> b2[i] then equal:=false
end;
{********************************************************************}
begin   {main program}
     initialize;
     for i:=1 to n do zero[i]:=0;
     normal:=0;
     for i:=1 to Tn-1 do                     {Find the normalization term}
         begin
              Convert_to_binary(i,b1,size);
              for j:=1 to Tn-1 do
                  begin
                       Convert_to_binary(j,b2,size);
                       common(n,b1,b2,b3);
                       if equal(n,b3,zero) then normal := m1[i]*m2[j] + normal;
                  end;
         end;
     normal:=1-normal;
     error:=false;
     if normal <= 0 then error := true;
     if error = false then
     begin
     for i:=1 to Tn-1 do
         begin
              mass:=0;
              Convert_to_binary(i,b1,size);
              for j:=1 to Tn-1 do
                  begin
                       Convert_to_binary(j,b2,size);
                       for k:=1 to Tn-1 do
                           begin
                                Convert_to_binary(k,b3,size);
                                common(n,b2,b3,b4);
                                if equal(n,b1,b4) then mass:=mass+m1[j]*m2[k];
                           end;
                  end;
              m3[i]:=mass/normal
         end;
     ClrScr;
     writeln;
     writeln('   Report of Combined Belief');
     writeln;
     ClrScr;
     writeln('                 RESULTS');
     writeln;
     writeln('Position    Alternative');
     for i:=1 to n do
         writeln('   ',i:2,'        ',A[i]);
     writeln;
     x:=WhereX;
     y:=WhereY;
     writeln('   Alternatives        Mass1      Mass2          Result');
     for i:=1 to Tn-1 do
         begin
              Convert_to_Binary(i,b,size);
              y:=y+1;
              write('        ');
              for j:=1 to n do
                  write(b[j]:1);
              GotoXY(25,y);
              writeln(m1[i]:3:2,'       ',m2[i]:3:2,'        ',m3[i]:3:2)
         end;
     writeln;
     writeln('Hit Return to continue');
     readln
  end;
end.
